--[[
Juju's Unnamed RPG Engine Demo
Sprites by DJ Omnimaga
Engine by Juju
--]]

-- characters.png notes:
-- Eljin, Merix, Zormy, Guil, Ji, Manu pi Kyra
-- de gauche a droite pi de haut en bas

function love.load()
	scale = 2
	gametime = 0
	gamestate = "introcredits"
	omnilogo = love.graphics.newImage("omnimaga_logo.gif")
	characters = love.graphics.newImage("characters.png")
	characters:setFilter("nearest", "linear")
	character = {}
	character.x = 116
	character.y = 96
	character.id = 0
	character.orientation = 2
	character.state = 1

	names = {[0]="Eljin", "Merix", "Zormy", "Guil", "Ji", "Manu", "Kyra"}
	
	deffont = love.graphics.newFont("FFI.ttf", 24)
	gamefont = love.graphics.newFont("FFI.ttf", 24*scale)
	love.graphics.setFont(gamefont)
	love.graphics.setColor(255,255,255,255)
	love.graphics.setBackgroundColor(0,0,0)
	love.graphics.setCaption("The Game")
	love.graphics.setMode(256*scale, 224*scale, false)
	love.graphics.scale(scale, scale)
end

function love.keypressed(key)
	if gamestate == "introcredits" then
		if love.keyboard.isDown("return") then
			gamestate = "menu"
		end
	elseif gamestate == "menu" then
		if key == "return" then
			gamestate = "game"
		elseif key == "escape" then
			love.event.push("quit")
		end
	elseif gamestate == "game" then
		if key == "escape" then
			gamestate = "menu"
		end
		if key == "p" then
			character.id = character.id+1
			if character.id >= 7 then
				character.id = 0
			end
		--[[
		elseif key == "o" then
			if scale == 1 then scale = 2 else scale = 1 end
			love.graphics.setMode(256*scale, 224*scale, false)
			love.graphics.scale(scale, scale)
		--]]
		end
	end
end

function love.update(dt)
	gametime = gametime+dt;

	if gamestate == "introcredits" then
		if gametime >= 3 then
			gamestate = "menu"
		end
	elseif gamestate == "menu" then
		-- Nothing happens here.
	elseif gamestate == "game" then
		character.state = 1
		if love.keyboard.isDown("left") then
			character.x = character.x-1
			character.orientation = 3
			character.state = math.floor(gametime*4)%4
		end
		if love.keyboard.isDown("right") then
			character.x = character.x+1
			character.orientation = 1
			character.state = math.floor(gametime*4)%4
		end
		if love.keyboard.isDown("up") then
			character.y = character.y-1
			character.orientation = 0
			character.state = math.floor(gametime*4)%4
		end
		if love.keyboard.isDown("down") then
			character.y = character.y+1
			character.orientation = 2
			character.state = math.floor(gametime*4)%4
		end
		if character.state >= 3 then character.state = 1 end
		if character.x < 10 then character.x = 10 end
		if character.x > 222 then character.x = 222 end
		if character.y < 10 then character.y = 10 end
		if character.y > 182 then character.y = 182 end
	end
end

function love.draw()
	love.graphics.setFont(deffont)
	love.graphics.print("FPS "..love.timer.getFPS(), 0, -11) -- .."  GT "..gametime

	if gamestate == "introcredits" then -- Intro
		love.graphics.draw(omnilogo, 50*scale, 100*scale, 0, scale*0.5) -- 320*(83-gametime)
		love.graphics.setFont(gamefont)
		love.graphics.print("presents", 50*scale, 112*scale) -- 344*(83*gametime)
	elseif gamestate == "menu" then -- Draw the menu
		love.graphics.setFont(gamefont)
		love.graphics.print("Juju's RPG Engine Demo", 50*scale, 50*scale)
		love.graphics.print("Press ENTER", 85*scale, 150*scale)
		love.graphics.print("(C) 2012 Omnimaga", 60*scale, 180*scale)
		love.graphics.setFont(deffont)		
		love.graphics.print("v0.0.0", 0, 215*scale)
	elseif gamestate == "game" then -- We're in the game
		love.graphics.setFont(deffont)
		love.graphics.print(names[character.id], 0, -3)
		love.graphics.setFont(gamefont)
		charquad = love.graphics.newQuad((character.id%4)*72+character.state*24, math.floor(character.id/4)*128+character.orientation*32, 24, 32, 288, 256)
		love.graphics.drawq(characters, charquad, character.x*scale, character.y*scale, 0, scale)
	end
end
